package com.hotwj.platform.config.accidentLevelConfig.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.accidentLevelConfig.domain.HotAccidentLevelConfig;
import com.hotwj.platform.config.accidentLevelConfig.domain.bo.HotAccidentLevelConfigBo;
import com.hotwj.platform.config.accidentLevelConfig.domain.vo.HotAccidentLevelConfigVo;
import com.hotwj.platform.config.accidentLevelConfig.mapper.HotAccidentLevelConfigMapper;
import com.hotwj.platform.config.accidentLevelConfig.service.IHotAccidentLevelConfigService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 事故等级划分Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-06
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotAccidentLevelConfigServiceImpl implements IHotAccidentLevelConfigService {

    private final HotAccidentLevelConfigMapper baseMapper;

    /**
     * 查询事故等级划分
     *
     * @param id 主键
     * @return 事故等级划分
     */
    @Override
    public HotAccidentLevelConfigVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询事故等级划分列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 事故等级划分分页列表
     */
    @Override
    public TableDataInfo<HotAccidentLevelConfigVo> queryPageList(HotAccidentLevelConfigBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotAccidentLevelConfig> lqw = buildQueryWrapper(bo);
        Page<HotAccidentLevelConfigVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的事故等级划分列表
     *
     * @param bo 查询条件
     * @return 事故等级划分列表
     */
    @Override
    public List<HotAccidentLevelConfigVo> queryList(HotAccidentLevelConfigBo bo) {
        LambdaQueryWrapper<HotAccidentLevelConfig> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotAccidentLevelConfig> buildQueryWrapper(HotAccidentLevelConfigBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotAccidentLevelConfig> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotAccidentLevelConfig::getId);
        lqw.eq(bo.getMinRiskValue() != null, HotAccidentLevelConfig::getMinRiskValue, bo.getMinRiskValue());
        lqw.eq(bo.getMaxRiskValue() != null, HotAccidentLevelConfig::getMaxRiskValue, bo.getMaxRiskValue());
        lqw.like(StringUtils.isNotBlank(bo.getLevelName()), HotAccidentLevelConfig::getLevelName, bo.getLevelName());
        lqw.eq(StringUtils.isNotBlank(bo.getControlLevel()), HotAccidentLevelConfig::getControlLevel, bo.getControlLevel());
        lqw.eq(StringUtils.isNotBlank(bo.getControlMeasureLevel()), HotAccidentLevelConfig::getControlMeasureLevel, bo.getControlMeasureLevel());
        lqw.eq(StringUtils.isNotBlank(bo.getDeadlineDesc()), HotAccidentLevelConfig::getDeadlineDesc, bo.getDeadlineDesc());
        lqw.eq(bo.getIsDeleted() != null, HotAccidentLevelConfig::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增事故等级划分
     *
     * @param bo 事故等级划分
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotAccidentLevelConfigBo bo) {
        HotAccidentLevelConfig add = MapstructUtils.convert(bo, HotAccidentLevelConfig.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改事故等级划分
     *
     * @param bo 事故等级划分
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotAccidentLevelConfigBo bo) {
        HotAccidentLevelConfig update = MapstructUtils.convert(bo, HotAccidentLevelConfig.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotAccidentLevelConfig entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除事故等级划分信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
